#taken from: https://stackoverflow.com/questions/29954815/merge-multiple-declarative-bases-in-sqlalchemy
from sqlalchemy import MetaData
from sqlalchemy.ext.declarative import declarative_base
from .models_core import (
        Timeseries,
        TimeseriesRole,
        TimeseriesTimeseriesRoles,
        Base as TimeseriesBase)
from .models_annotation import (
        TimeseriesAnnotation,
        Base as TimeseriesAnnotationBase)
from .models_programme import (
        TimeseriesProgramme,
        Base as TimeseriesProgrammBase)

Base = declarative_base()
metadata = MetaData()

from sqlalchemy import Table, String, Column, ForeignKey, Integer
from sqlalchemy.ext.declarative import declarative_base

Base = declarative_base()
metadata = Base.metadata

for declarative_base in [TimeseriesBase, TimeseriesAnnotationBase, TimeseriesProgrammBase]:
    for (table_name, table) in declarative_base.metadata.tables.items():
        metadata._add_table(table_name, table.schema, table)

Base.metadata = metadata

"""
Table "public.timeseries_timeseries_annotations"
+---------------+---------+-----------+----------+---------+
|    Column     |  Type   | Collation | Nullable | Default |
+===============+=========+===========+==========+=========+
| timeseries_id | integer |           | not null |         |
+---------------+---------+-----------+----------+---------+
| annotation_id | integer |           | not null |         |
+---------------+---------+-----------+----------+---------+
Indexes:
    "timeseries_timeseries_annotations_pkey" PRIMARY KEY, btree (timeseries_id, annotation_id)
Foreign-key constraints:
    "timeseries_timeseries_annotations_annotation_id_fkey" FOREIGN KEY (annotation_id) REFERENCES timeseries_annotations(id)
    "timeseries_timeseries_annotations_timeseries_id_fkey" FOREIGN KEY (timeseries_id) REFERENCES timeseries(id)
"""
##t_timeseries_timeseries_annotations = Table(
##    'timeseries_timeseries_annotations', metadata,
##    Column('timeseries_id', ForeignKey('timeseries.id'), primary_key=True, nullable=False),
##    Column('annotation_id', ForeignKey('timeseries_annotations.id'), primary_key=True, nullable=False)
##)

"""
Table "public.timeseries_timeseries_programmes"
+---------------+---------+-----------+----------+---------+
|    Column     |  Type   | Collation | Nullable | Default |
+===============+=========+===========+==========+=========+
| timeseries_id | integer |           | not null |         |
+---------------+---------+-----------+----------+---------+
| programme_id  | integer |           | not null |         |
+---------------+---------+-----------+----------+---------+
Indexes:
    "timeseries_timeseries_programmes_pkey" PRIMARY KEY, btree (timeseries_id, programme_id)
Foreign-key constraints:
    "timeseries_timeseries_programmes_programme_id_fkey" FOREIGN KEY (programme_id) REFERENCES timeseries_programmes(id)
    "timeseries_timeseries_programmes_timeseries_id_fkey" FOREIGN KEY (timeseries_id) REFERENCES timeseries(id)
"""

##t_timeseries_timeseries_programmes = Table(
##    'timeseries_timeseries_programmes', metadata,
##    Column('timeseries_id', ForeignKey('timeseries.id'), primary_key=True, nullable=False),
##    Column('programme_id', ForeignKey('timeseries_programmes.id'), primary_key=True, nullable=False)
##)

## class TimeseriesTimeseriesRoles(Base):
##     """
##     Table "public.timeseries_timeseries_roles"
##     +---------------+---------+-----------+----------+---------+
##     |    Column     |  Type   | Collation | Nullable | Default |
##     +===============+=========+===========+==========+=========+
##     | timeseries_id | integer |           | not null |         |
##     +---------------+---------+-----------+----------+---------+
##     | role_id       | integer |           | not null |         |
##     +---------------+---------+-----------+----------+---------+
##     Indexes:
##         "timeseries_timeseries_roles_pkey" PRIMARY KEY, btree (timeseries_id, role_id)
##     Foreign-key constraints:
##         "timeseries_timeseries_roles_role_id_fkey" FOREIGN KEY (role_id) REFERENCES timeseries_roles(id)
##         "timeseries_timeseries_roles_timeseries_id_fkey" FOREIGN KEY (timeseries_id) REFERENCES timeseries(id)
##    """

##     __tablename__ = 'timeseries_timeseries_roles'

##     timeseries_id = Column(Integer, ForeignKey(Timeseries.id), primary_key=True, nullable=False)
##     role_id = Column(Integer, ForeignKey(TimeseriesRole.id), primary_key=True, nullable=False)


# controlled vocabulary
RS_enum = Table("rs_vocabulary",
                metadata,
                Column("enum_val", Integer, primary_key=True),
                Column("enum_str", String),
                Column("enum_display_str", String)
          )

RC_enum = Table("rc_vocabulary",
                metadata,
                Column("enum_val", Integer, primary_key=True),
                Column("enum_str", String),
                Column("enum_display_str", String)
          )
