# coding: utf-8
"""
class TimeseriesProgramme (Base)
================================
"""
from sqlalchemy import Column, Integer, text, String, Text 
from sqlalchemy.ext.declarative import declarative_base

Base = declarative_base()
metadata = Base.metadata


# this has at the moment no relation to anything!!!
class TimeseriesProgramme(Base):
    """ Table "public.timeseries_programmes"

    +-------------+------------------------+-----------+----------+---------------------------------------------------+
    |  Column     |          Type          | Collation | Nullable |                      Default                      |
    +=============+========================+===========+==========+===================================================+
    | id          | integer                |           | not null | nextval('timeseries_programmes_id_seq'::regclass) |
    +-------------+------------------------+-----------+----------+---------------------------------------------------+
    | name        | character varying(32)  |           | not null |                                                   |
    +-------------+------------------------+-----------+----------+---------------------------------------------------+
    | longname    | character varying(128) |           | not null |                                                   |
    +-------------+------------------------+-----------+----------+---------------------------------------------------+
    | homepage    | character varying(200) |           | not null |                                                   |
    +-------------+------------------------+-----------+----------+---------------------------------------------------+
    | description | text                   |           | not null |                                                   |
    +-------------+------------------------+-----------+----------+---------------------------------------------------+
    Indexes:
     "timeseries_programmes_pkey" PRIMARY KEY, btree (id)
    """
    __tablename__ = 'timeseries_programmes'

    id = Column(Integer, primary_key=True, server_default=text("nextval('timeseries_programmes_id_seq'::regclass)"))
    name = Column(String(32), nullable=False)
    longname = Column(String(128), nullable=False)
    homepage = Column(String(200), nullable=False)
    description = Column(Text, nullable=False)

