"""
Simple test API for variable management
"""

from typing import List
from fastapi import FastAPI, Depends, HTTPException, APIRouter
from sqlalchemy.orm import Session

from toardb.utils.database import ToarDbSession

from toardb.variables import variables
from toardb.contacts import contacts
from toardb.stationmeta import stationmeta
from toardb.timeseries import timeseries
from toardb.data import data


app = FastAPI()

# Dependency
def get_db():
    try:
        db = ToarDbSession()
        yield db
    finally:
        db.close()

app.include_router(variables.router)
app.include_router(contacts.router)
app.include_router(stationmeta.router)
app.include_router(timeseries.router)
app.include_router(data.router)

